<?php
/**
 * ------------------------------------------------------------------------
 * JA Content Extra Fields for Joomla 2.5
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// Ensure this file is being included by a parent file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.html.parameter');
jimport('joomla.form.form');
jimport('joomla.filesystem.file');
/**
 * JA Extra Fields Content Plugin Group
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.7
 */
class JFormFieldJaextrafieldsgroups extends JFormField
{
    /**
     * Element name
     *
     * @access	protected
     * @var		string
     */
    protected $type = 'Jaextrafieldsgroups';


    /**
     * Method to get the field input markup.
     *
     * @return	string	The field input markup.
     * @since	1.6
     */
    protected function getInput()
    {
        // Initialize variables.
        $html = array();
        $attr = '';
        $attr .= ' size=5';
        $attr .= ' multiple="multiple"';
        $fieldsets = $this->getFieldsets();
        $options = array();

        foreach ($fieldsets as $k => $fieldset) {
            $options_elm = array();
            $options_elm['value'] = $fieldset;
            $options_elm['text'] = $fieldset;
            $options_elm['level'] = 0;
            $options[] = $options_elm;
        }

        $html[] = JHtml::_('select.genericlist', $options, $this->name . '[]', trim($attr), 'value', 'text', $this->value, $this->id);

        return implode($html);
    }


    /**
     *
     * Get extra fields from xml file
     * @return object extra fields
     */
    function getFieldsets()
    {
        $xml = & JFactory::getXMLParser('Simple');
        //$path = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'jacontentextrafields'.DS.'params'.DS.'article.xml';
        $tPathArticle = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . 'jacontentextrafields' . DS . 'article.xml';
        $bPathArticle = JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'jacontentextrafields' . DS . 'params' . DS . 'article.xml';
        // If the template has a layout override use it


        if (file_exists($tPathArticle)) {
            $path = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . 'jacontentextrafields' . DS . 'article.xml';
        } elseif (file_exists($bPathArticle)) {
            $path = JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'jacontentextrafields' . DS . 'params' . DS . 'article.xml';
        }

        //echo JPATH_SITE. DS . 'templates' . DS . $mainframe->getTemplate () . DS . 'html' . DS . 'jacontentextrafields';exit;
        $fieldsets = array();
        if ($xml->loadFile($path)) {
            $temp_info = & $xml->document;

            if (isset($temp_info->_children) && count($temp_info->_children)) {
                foreach ($temp_info->_children as $node) {
                    foreach ($node->_children as $fieldset) {
                        if ($fieldset->_name == "fieldset") {
                            $fieldsets[$fieldset->_attributes['name']] = $fieldset->_attributes['name'];
                        }
                    }
                }
            }

        }

        return $fieldsets;
    }


    /**
     *
     * Get template actived
     * @return string template name
     */
    function get_active_template()
    {
        $db = & JFactory::getDBO();

        // Get the current default template
        $query = ' SELECT template ' . ' FROM #__template_styles ' . ' WHERE client_id = 0' . ' AND home = 1 ';
        $db->setQuery($query);
        $template = $db->loadResult();

        return $template;
    }
}
?>

