<?php
/**
 * ------------------------------------------------------------------------
 * JA Content Extra Fields for Joomla 2.5
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// Ensure this file is being included by a parent file
defined('_JEXEC') or die('Restricted access');
/**
 * JA Extra Fields Content Plugin Layout
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.7
 */
class JFormFieldJalayouts extends JFormFieldList
{
    /**
     * The form field type.
     *
     * @var		string
     * @since	1.6
     */
    public $type = 'jalayouts';


    /**
     * Method to get the field options.
     *
     * @return	array	The field option objects.
     * @since	1.6
     */
    protected function getOptions()
    {
        // Initialize variables.
        $options = array();

        // Initialize some field attributes.
        $filter = (string) $this->element['filter'];
        $exclude = (string) $this->element['exclude'];
        $stripExt = (string) $this->element['stripext'];
        $hideNone = (string) $this->element['hide_none'];
        $hideDefault = (string) $this->element['hide_default'];

        $tFiles = array();
        $bFiles = array();

        // Get the path in which to search for file options.
        $tPath = JPATH_ROOT . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . 'jacontentextrafields';
        $bPath = JPATH_ROOT . DS . 'plugins' . DS . 'system' . DS . 'jacontentextrafields' . DS . 'tmpl';

        // Get a list of files in the search path with the given filter.
        if (JFolder::exists($tPath))
            $tFiles = JFolder::files($tPath, $filter);

        if (JFolder::exists($bPath))
            $bFiles = JFolder::files($bPath, $filter);

        $files = array_unique(array_merge($tFiles, $bFiles));

        // Prepend some default options based on field attributes.
        if (!$hideNone) {
            $options[] = JHtml::_('select.option', '-1', JText::_('JOPTION_DO_NOT_USE'));
        }
        if (!$hideDefault) {
            $options[] = JHtml::_('select.option', '', JText::_('JOPTION_USE_DEFAULT'));
        }

        // Build the options list from the list of files.
        if (is_array($files)) {
            $filesName = array();
            foreach ($files as $file) {

                // Check to see if the file is in the exclude mask.
                if ($exclude) {
                    if (preg_match(chr(1) . $exclude . chr(1), $file)) {
                        continue;
                    }
                }

                // If the extension is to be stripped, do it.
                if ($stripExt) {
                    $file = JFile::stripExt($file);
                }

                if (!in_array($file, $filesName)) {
                    $filesName[] = $file;
                    $options[] = JHtml::_('select.option', $file, $file);
                }

            }
        }

        // Merge any additional options in the XML definition.
        $options = array_merge(parent::getOptions(), $options);

        return $options;
    }


    /**
     *
     * Get template actived
     * @return string template name
     */
    function get_active_template()
    {
        $db = & JFactory::getDBO();

        // Get the current default template
        $query = ' SELECT template ' . ' FROM #__template_styles ' . ' WHERE client_id = 0' . ' AND home = 1 ';
        $db->setQuery($query);
        $template = $db->loadResult();

        return $template;
    }
}