<?php
/**
 * ------------------------------------------------------------------------
 * JA Content Extra Fields for Joomla 2.5
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
jimport('joomla.application.module.helper');
jimport('joomla.application.categories');
/**
 * JA Extra Fields Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.7
 */
class plgSystemJacontentextrafields extends JPlugin
{


    /**
     * Constructor
     *
     * For php4 compatability we must not use the __constructor as a constructor for plugins
     * because func_get_args ( void ) returns a copy of all passed arguments, NOT references.
     * This causes problems with cross-referencing necessary for the observer design pattern.
     *
     * @param	object	$subject The object to observe
     * @param	object 	$config  The object to observe
     */
    function plgSystemJacontentextrafields(&$subject, $config)
    {
        $mainframe = JFactory::getApplication();

        parent::__construct($subject, $config);
        $this->plugin = &JPluginHelper::getPlugin('system', 'jacontentextrafields');
        jimport('joomla.html.parameter');
        $this->loadLanguage(null, JPATH_ADMINISTRATOR);
    }


    /**
     * only render button some postions such as TOP, BOTTOM, CUSTOM LOCATION.
     */
    function onContentPrepare($context, &$article, &$params, $page = 1)
    {

        return true;
    }


    //Add JA Extended Article parameters - used for Joomla 1.7
    /**
     *
     * Add extral fields into Article parameters
     * Used for Joomla 1.7
     * @param string $form
     * @param array $data
     * @return string form add, edit a Article
     */
    function onContentPrepareForm($form, $data)
    {
        $plugin = $this->plugin;
        if ($form->getName() == 'com_categories.categorycom_content') {

            // Load setting for Ja content extra fields in category
            $tPathArticle = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'category.xml';
            $pPathArticle = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'category.xml';
            $pPathCatLayout = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'category_layout.xml';
            if (JFile::exists($tPathArticle)) {
                JForm::addFormPath(JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name);
                $pPathArticle = $tPathArticle;
            } elseif (JFile::exists($pPathArticle)) {
                JForm::addFormPath(JPATH_SITE . DS . "plugins" . DS . "system" . DS . "jacontentextrafields" . DS . "params");
            } else {
                JError::raiseError(-1, JText::_('category.xml file not exist.'));
                return;
            }

            if (JFile::exists($pPathCatLayout)) {
                $form->loadFile('category_layout', false);
            }

            $form->loadFile('category', false);

            $xml = & JFactory::getXMLParser('Simple');

            $fieldsets = array();
            if ($xml->loadFile($pPathArticle)) {
                $temp_info = & $xml->document;

                if (isset($temp_info->_children) && count($temp_info->_children)) {
                    foreach ($temp_info->_children as $node) {
                        foreach ($node->_children as $fieldset) {
                            $fieldsets[] = $fieldset->_attributes['name'];
                        }
                    }
                }

            }
            $xml = & JFactory::getXMLParser('Simple');
            if ($xml->loadFile($pPathCatLayout)) {
                $temp_info = & $xml->document;

                if (isset($temp_info->_children) && count($temp_info->_children)) {
                    foreach ($temp_info->_children as $node) {
                        foreach ($node->_children as $fieldset) {
                            $fieldsets[] = $fieldset->_attributes['name'];
                        }
                    }
                }

            }
			
			
			if(JRequest::getVar('jatypo', 0) != 'show'):
            ?>

			<script type="text/javascript">
				window.addEvent( "load", function(){
				<?php
            if (count($fieldsets) > 0) {
                foreach ($fieldsets as $fieldset) {
                    ?>
					var elements = $('<?php
                    echo $fieldset;
                    ?>-options').getParent().getChildren('div fieldset ul li');
					elements.each(function(el){
						el.getChildren('#jform_note').getParent('li').destroy();
					});
				<?php
                }
            }
            ?>
				} );
			</script>
        <?php
			endif;
        }

        if ($form->getName() == 'com_content.article') {
            // End load setting


            $catid = 0;
            foreach ($data as $key => $value) {
                if ($key == "catid") {
                    $catid = $value;
                }
            }
            $categories = JCategories::getInstance('Content');
            $category = $categories->get($catid);

            $cat_params = json_decode($category->get('params', ''));

            $groups = array();

            foreach ($cat_params as $k => $cat_param) {
                if ($k == 'extra-fields-groups') {
                    $groups = $cat_param;
                }
            }

            //if(count($groups)>0){


            $fieldsets = $this->getFieldsets();
            $remove_extras = array();
            if ($fieldsets) {
                foreach ($fieldsets as $k => $fieldset) {
                    if (!in_array($fieldset, $groups)) {
                        $remove_extras[] = $fieldset;
                    }
                }
            }

            $tPathArticle = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'article.xml';
            $pPathArticle = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'article.xml';
            if (JFile::exists($tPathArticle)) {
                JForm::addFormPath(JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name);
            } elseif (JFile::exists($pPathArticle)) {
                // Load setting for Ja content extra fields in category
                JForm::addFormPath(JPATH_SITE . DS . "plugins" . DS . "system" . DS . "jacontentextrafields" . DS . "params");
            } else {
                JError::raiseError(-1, JText::_('article.xml file not exist.'));
                return;
            }
            $form->loadFile('layout', false);
            $form->loadFile('article', false);
			
            ?>
			
			<?php
				if(JRequest::getVar('jatypo', 0) != 'show'):
			?>
				<script type="text/javascript">
					window.addEvent( "load", function(){
					<?php
				if (count($remove_extras) > 0) {
					foreach ($remove_extras as $removed) {
						?>
							if ($( '<?php
						echo $removed;
						?>-options')){
								$( '<?php
						echo $removed;
						?>-options').getParent('div').destroy();
							}
					<?php
					}
				}
				?>
					} );
			   </script>
			<?php
				endif;
			?>
    <?php

        }
    }


    /**
     *
     * Process content with extra field layout of Article after display
     * @param string $context
     * @param object $article
     * @param object $params
     * @param int $limitstart
     * @return string extra field layout
     */
    public function onContentAfterDisplay($context, &$article, &$params, $limitstart = 0)
    {

        $mainframe = JFactory::getApplication();
        $this->plgParams = new JParameter($this->plugin->params);
        //$this->plgdisplay   = $this->plgParams->get('display', '1');
        $this->position = $this->plgParams->get('position', 'beforecontent');
        $plgParams = $this->plgParams;
        if ($mainframe->isAdmin()) {
            return '';
        }

        if ($this->position == 'aftercontent') {

            $option = JRequest::getVar('option');
            $view = JRequest::getVar('view');
            $id = JRequest::getInt('id');

            if ($view == 'frontpage')
                return '';

            if ($context == 'com_content.article') {
                $article_params = json_decode($article->attribs);
                $this->article_params = $article_params;
                $categories = JCategories::getInstance('Content');
                $category = $categories->get($article->catid);
                $cat_params = json_decode($category->get('params', ''));

                $article_display_on_home = isset($article_params->display_on_home) ? $article_params->display_on_home : "default";
                $cat_display_on_home = isset($cat_params->display_on_home) ? $cat_params->display_on_home : "default";
                $plugin_display_on_home = (int) $plgParams->get('display_on_home', 1);

                $article_display_on_list = isset($article_params->display_on_list) ? $article_params->display_on_list : "default";
                $cat_display_on_list = isset($cat_params->display_on_list) ? $cat_params->display_on_list : "default";
                $plugin_display_on_list = (int) $plgParams->get('display_on_list', 1);

                $display_on_home = ($article_display_on_home != "default") ? $article_display_on_home : (($cat_display_on_home != "default") ? $cat_display_on_home : $plugin_display_on_home);

                $display_on_list = ($article_display_on_list != "default") ? $article_display_on_list : (($cat_display_on_list != "default") ? $cat_display_on_list : $plugin_display_on_list);

                $id = JRequest::getInt('id');

                if ($view == 'featured' && $display_on_home != 1)
                    return "";
                if (($view == 'categories') && ($display_on_list != 1))
                    return "";
                if (($view == 'category') && ($display_on_list != 1))
                    return "";

                $ext_params = array();
                foreach ($cat_params as $k => $v) {
                    if ($k == 'extra-fields-groups') {
                        foreach ($v as $fieldset) {
                            $ext_params = array_merge($ext_params, $this->getFieldsetParams($fieldset));
                        }
                    }
                }

                $this->ext_params = $ext_params;

                $article_layout = isset($article_params->layout) ? $article_params->layout : "";
                $cat_layout = isset($cat_params->layout) ? $cat_params->layout : "default";
                $plugin_layout = $this->plgParams->get('layout', 'default');

                $layout = ($article_layout != "") ? $article_layout : (($cat_layout != "default") ? $cat_layout : $plugin_layout);

                $article_display = isset($article_params->display) ? $article_params->display : "default";
                $cat_display = isset($cat_params->display) ? $cat_params->display : "default";

                $display = ($article_display != "default") ? $article_display : (($cat_display != "default") ? $cat_display : $this->plgParams->get('display', '1'));
                if (!$display)
                    return '';

                $addition = $this->loadLayout($this->plugin, $layout);
                return $addition;
            }
        }
    }


    /**
     *
     * Process content with extra field layout of Article before display
     * @param string $context
     * @param object $row
     * @param object $params
     * @param int $page
     * @return string extra field layout
     */
    public function onContentBeforeDisplay($context, &$row, &$params, $page = 0)
    {

        $mainframe = JFactory::getApplication();
        $this->plgParams = new JParameter($this->plugin->params);
        //$this->plgdisplay   = $this->plgParams->get('display', '1');
        $this->position = $this->plgParams->get('position', 'beforecontent');
        $plgParams = $this->plgParams;
        if ($mainframe->isAdmin()) {
            return '';
        }

        if ($this->position == 'beforecontent') {

            $option = JRequest::getVar('option');
            $view = JRequest::getVar('view');
            $id = JRequest::getInt('id');

            if ($view == 'frontpage')
                return '';

            if ($context == 'com_content.article') {
                $article_params = json_decode($row->attribs);
                $this->article_params = $article_params;
                $categories = JCategories::getInstance('Content');
                $category = $categories->get($row->catid);
                $cat_params = json_decode($category->get('params', ''));

                //$layout = ($article_layout != "") ? $article_layout : (($cat_layout != "") ? $cat_layout : $plugin_layout);


                $article_display_on_home = isset($article_params->display_on_home) ? $article_params->display_on_home : "default";
                $cat_display_on_home = isset($cat_params->display_on_home) ? $cat_params->display_on_home : "default";
                $plugin_display_on_home = (int) $plgParams->get('display_on_home', 1);

                $article_display_on_list = isset($article_params->display_on_list) ? $article_params->display_on_list : "default";
                $cat_display_on_list = isset($cat_params->display_on_list) ? $cat_params->display_on_list : "default";
                $plugin_display_on_list = (int) $plgParams->get('display_on_list', 1);

                $display_on_home = ($article_display_on_home != "default") ? $article_display_on_home : (($cat_display_on_home != "default") ? $cat_display_on_home : $plugin_display_on_home);

                $display_on_list = ($article_display_on_list != "default") ? $article_display_on_list : (($cat_display_on_list != "default") ? $cat_display_on_list : $plugin_display_on_list);

                $id = JRequest::getInt('id');

                if ($view == 'featured' && $display_on_home != 1)
                    return "";
                if (($view == 'categories') && ($display_on_list != 1))
                    return "";
                if (($view == 'category') && ($display_on_list != 1))
                    return "";

                $ext_params = array();
                foreach ($cat_params as $k => $v) {
                    if ($k == 'extra-fields-groups') {
                        foreach ($v as $fieldset) {
                            $ext_params = array_merge($ext_params, $this->getFieldsetParams($fieldset));
                        }
                    }
                }

                $this->ext_params = $ext_params;

                $article_layout = isset($article_params->layout) ? $article_params->layout : "";
                $cat_layout = isset($cat_params->layout) ? $cat_params->layout : "default";
                $plugin_layout = $this->plgParams->get('layout', 'default');

                $layout = ($article_layout != "") ? $article_layout : (($cat_layout != "default") ? $cat_layout : $plugin_layout);

                $article_display = isset($article_params->display) ? $article_params->display : "default";
                $cat_display = isset($cat_params->display) ? $cat_params->display : "default";

                $display = ($article_display != "default") ? $article_display : (($cat_display != "default") ? $cat_display : $this->plgParams->get('display', '1'));
                if (!$display)
                    return '';

                $addition = $this->loadLayout($this->plugin, $layout);
                return $addition;
            }
        }
    }


    /**
     *
     * Get layout path for extra fields article
     * @param object $plugin
     * @param string $layout
     * @return string layout path
     */
    function getLayoutPath($plugin, $layout = 'default')
    {

        $plugin = $this->plugin;
        // Build the template and base path for the layout
        $tPath = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . $layout . '.php';
        $bPath = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'tmpl' . DS . $layout . '.php';
        // If the template has a layout override use it


        if (file_exists($tPath)) {
            return $tPath;
        } elseif (file_exists($bPath)) {
            return $bPath;
        } elseif ($layout != 'default') {
            return $this->getLayoutPath($plugin, 'default');
        }

        return '';
    }


    /**
     *
     * Load layout for display content
     * @param object $plugin
     * @param string $layout
     * @return string content
     */
    function loadLayout($plugin, $layout = 'default')
    {
        $layout_path = $this->getLayoutPath($plugin, $layout);
        if ($layout_path) {
            ob_start();
            require $layout_path;
            $content = ob_get_contents();
            ob_end_clean();
            return $content;
        }
        return '';
    }


    /**
     *
     * Get extra fields from xml file
     * @return object extra fields
     */
    function getFieldsets()
    {

        $xml = & JFactory::getXMLParser('Simple');
        $plugin = $this->plugin;
        //$path = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'jacontentextrafields'.DS."params".DS.'article.xml';
        $tPathArticle = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'article.xml';
        $bPathArticle = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'article.xml';
        // If the template has a layout override use it
        if (file_exists($tPathArticle)) {
            $path = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'article.xml';
        } elseif (file_exists($bPathArticle)) {
            $path = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'article.xml';
        }
        $fieldsets = array();

        if ($xml->loadFile($path)) {
            $temp_info = & $xml->document;

            if (isset($temp_info->_children) && count($temp_info->_children)) {
                foreach ($temp_info->_children as $node) {
                    foreach ($node->_children as $fieldset) {
                        if ($fieldset->_name == "fieldset") {
                            $fieldsets[$fieldset->_attributes['name']] = $fieldset->_attributes['name'];
                        }
                    }
                }
            }

        }

        return $fieldsets;
    }


    /**
     *
     * Get extra field set to Article Params
     * @param string $name field name
     * @return array field nam
     */
    function getFieldsetParams($name)
    {

        $xml = & JFactory::getXMLParser('Simple');
        $plugin = $this->plugin;
        $tPathArticle = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'article.xml';
        $bPathArticle = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'article.xml';
        // If the template has a layout override use it
        if (file_exists($tPathArticle)) {
            $path = JPATH_SITE . DS . 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . $plugin->name . DS . 'article.xml';
        } elseif (file_exists($bPathArticle)) {
            $path = JPATH_SITE . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name . DS . 'params' . DS . 'article.xml';
        } else {
            JError::raiseError(-1, JText::_('article.xml file not exist.'));
            return;
        }
        $fields = array();
        if ($xml->loadFile($path)) {
            $temp_info = & $xml->document;

            if (isset($temp_info->_children) && count($temp_info->_children)) {
                foreach ($temp_info->_children as $node) {
                    foreach ($node->_children as $fieldset) {
                        if ($fieldset->_attributes['name'] == $name) {
                            foreach ($fieldset->_children as $field) {
                                $fields[] = $field->_attributes['name'];
                            }
                        }
                    }
                }
            }

        }

        return $fields;
    }


    /**
     *
     * Get template actived
     * @return string template name
     */
    function get_active_template()
    {
        $db = & JFactory::getDBO();

        // Get the current default template
        $query = ' SELECT template '
               . ' FROM #__template_styles '
               . ' WHERE client_id = 0'
               . ' AND home = 1 ';
        $db->setQuery($query);
        $template = $db->loadResult();

        return $template;
    }


    /**
     * Get filter option
     * @return array filter option
     */
    protected function getOptions()
    {
        // Initialize variables.
        $options = array();

        // Initialize some field attributes.
        $filter = (string) $this->element['filter'];
        $exclude = (string) $this->element['exclude'];
        $stripExt = (string) $this->element['stripext'];
        $hideNone = (string) $this->element['hide_none'];
        $hideDefault = (string) $this->element['hide_default'];

        // Get the path in which to search for file options.
        $tPath = 'templates' . DS . strtolower($this->get_active_template()) . DS . 'html' . DS . 'jacontentextrafields';
        $bPath = 'plugins' . DS . 'system' . DS . 'jacontentextrafields' . DS . 'tmpl';

        // Prepend some default options based on field attributes.
        if (!$hideNone) {
            $options[] = JHtml::_('select.option', '-1', JText::_('JOPTION_DO_NOT_USE'));
        }
        if (!$hideDefault) {
            $options[] = JHtml::_('select.option', '', JText::_('JOPTION_USE_DEFAULT'));
        }

        // Get a list of files in the search path with the given filter.
        $tFiles = JFolder::files(JPATH_ROOT . DS . $tPath, $filter);
        $bFiles = JFolder::files(JPATH_ROOT . DS . $bPath, $filter);

        $files = array_unique(array_merge($tFiles, $bFiles));
        // Build the options list from the list of files.
        if (is_array($files)) {
            $filesName = array();
            foreach ($files as $file) {

                // Check to see if the file is in the exclude mask.
                if ($exclude) {
                    if (preg_match(chr(1) . $exclude . chr(1), $file)) {
                        continue;
                    }
                }

                // If the extension is to be stripped, do it.
                if ($stripExt) {
                    $file = JFile::stripExt($file);
                }

                if (!in_array($file, $filesName)) {
                    $filesName[] = $file;
                    $options[] = JHtml::_('select.option', $file, $file);
                }

            }
        }

        return $options;
    }
}
?>